/**
 * 
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard.buttons;

import com.trolltech.qt.gui.QRadioButton;
import edu.jhu.cs.oose.elevel.AdvancedEditCard.drawItems.DrawingItem;
import edu.jhu.cs.oose.elevel.AdvancedEditCard.drawItems.DrawingType;

/**
 * Radio button that has a DrawingType
 * 
 * @author Jesse Yates
 */
public class DrawingRadioButton extends QRadioButton implements DrawingButton
{
	private DrawingItem type;

	/**
	 * Constructor
	 * 
	 * @param name
	 *        The name of the button to display
	 * @param type
	 *        The drawingType associated with this button
	 */
	public DrawingRadioButton(String name, DrawingType type)
	{
		super(name);
		this.type = type.getItem();
	}

	/**
	 * The current type associated with this button
	 */
	public DrawingItem getType()
	{
		return this.type;
	}
}
