/**
 * 
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard.commands;

import com.trolltech.qt.gui.QGraphicsItemInterface;
import com.trolltech.qt.gui.QGraphicsScene;
import com.trolltech.qt.gui.QUndoCommand;

/**
 * @author Jesse Yates
 */
public class DrawItemCommand extends DrawCommand
{
	/**
	 * Impelmentation of the DrawCommand
	 * 
	 * @param add
	 *        Element to be added
	 * @param scene
	 *        The model to add the element to
	 */
	public DrawItemCommand(QGraphicsItemInterface add, QGraphicsScene scene)
	{
		this.item = add;
		this.canvas = scene;
	}

	/**
	 * Undo the previous command
	 */
	public void undo()
	{
		this.canvas.removeItem(item);
	}

	/**
	 * Redo the command. Called when added to the stack
	 */
	public void redo()
	{
		this.canvas.addItem(item);
	}

	/**
	 * Determine if this can be merged with another command. Currently no merging is instantiated
	 */
	public boolean mergeWith(QUndoCommand other)
	{
		return false;
	}

	/**
	 * Determines if this is a valid command
	 */
	@Override
	public boolean isValid()
	{
		if(item != null)
			return true;
		return false;
	}
}
