package edu.jhu.cs.oose.elevel.AdvancedEditCard.commands;

import com.trolltech.qt.core.QPointF;
import com.trolltech.qt.gui.QUndoCommand;

/**
 * Superclass to deal with resizing drag and drop items based on their rectangle
 * 
 * @author Jesse Yates
 */
public abstract class ResizeItemCommand extends QUndoCommand
{

	/** The old item position */
	protected QPointF oldP1;
	protected QPointF oldP2;
	/** The new item position */
	protected QPointF newP1;
	protected QPointF newP2;

	public ResizeItemCommand()
	{
		super();
	}

	public abstract boolean mergeWith(QUndoCommand command);

	public abstract void redo();

	public abstract void undo();

	public ResizeItemCommand(QUndoCommand parent)
	{
		super(parent);
	}

	public ResizeItemCommand(String text)
	{
		super(text);
	}

	public ResizeItemCommand(QPrivateConstructor p)
	{
		super(p);
	}

	public ResizeItemCommand(String text, QUndoCommand parent)
	{
		super(text, parent);
	}

}
