/**
 * 
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard.commands;

import com.trolltech.qt.core.QRectF;
import com.trolltech.qt.gui.QGraphicsRectItem;
import com.trolltech.qt.gui.QUndoCommand;

/**
 * Resize a rectangle command
 * 
 * @author Jesse Yates
 */
public class ResizeRectItemCommand extends ResizeItemCommand
{

	private QGraphicsRectItem item;

	/**
	 * Constructor
	 * 
	 * @param oldRect
	 *        The previous item position
	 * @param item
	 *        The current item
	 */
	public ResizeRectItemCommand(QRectF oldRect, QGraphicsRectItem item)
	{
		this.oldP1 = oldRect.topLeft();
		this.oldP2 = oldRect.bottomRight();
		this.newP1 = item.rect().topLeft();
		this.newP2 = item.rect().bottomRight();
		this.item = item;
	}

	/* (non-Javadoc)
	 * @see edu.jhu.cs.oose.elevel.AdvancedEditCard.commands.ResizeItemCommand#mergeWith(com.trolltech.qt.gui.QUndoCommand)
	 */
	@Override
	public boolean mergeWith(QUndoCommand command)
	{
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.jhu.cs.oose.elevel.AdvancedEditCard.commands.ResizeItemCommand#redo()
	 */
	@Override
	public void redo()
	{
		item.prepareGeometryChange();
		item.setRect(new QRectF(this.newP1, this.newP2));

	}

	/* (non-Javadoc)
	 * @see edu.jhu.cs.oose.elevel.AdvancedEditCard.commands.ResizeItemCommand#undo()
	 */
	@Override
	public void undo()
	{
		item.prepareGeometryChange();
		item.setRect(new QRectF(this.oldP1, this.oldP2));

	}

}
