/**
 * 
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard.drawItems;

import com.trolltech.qt.core.QRectF;
import com.trolltech.qt.gui.QGraphicsEllipseItem;
import com.trolltech.qt.gui.QGraphicsSceneMouseEvent;
import edu.jhu.cs.oose.elevel.AdvancedEditCard.DrawingGraphicsScene;
import edu.jhu.cs.oose.elevel.AdvancedEditCard.dragDrop.DragDropEllipse;

/**
 * @author Jesse Yates
 */
public class DrawingEllipseItem extends DrawingItem
{
	private QGraphicsEllipseItem current;

	public DrawingEllipseItem(double x, double y, double height, double width, DrawingGraphicsScene scene)
	{
		this(scene);
		this.current = new QGraphicsEllipseItem(x, y, height, width);
	}

	public DrawingEllipseItem(DrawingGraphicsScene scene)
	{
		super(scene);
	}

	public DrawingEllipseItem()
	{
		this(new DrawingGraphicsScene());
	}

	/*
	 * (non-Javadoc)
	 * @see edu.jhu.cs.oose.development.DrawingItem#buildFromString(java.lang.String)
	 */
	public void buildFromString(String item)
	{
		// TODO Auto-generated method stub

	}

	/**
	 * If there is already an object at the current location, does not do anything, passes on the mouse click to that
	 * element. Otherwise, creates a circle starting at that location
	 * 
	 * @param event
	 *        the event that is being acted on
	 */
	public void mousePressEvent(QGraphicsSceneMouseEvent event)
	{
		System.out.println("Circle Press event");
		/*
		 * if(this.scene.itemAt(event.scenePos()) != null && this.scene.isSelectMode())
		 * {
		 * System.out.println("Item is not null!");
		 * //this.itemAt(event.scenePos()).mouseMoveEvent(event);// setFocus(Qt.FocusReason.MouseFocusReason);
		 * }
		 * else
		 */
		{

			this.current = new QGraphicsEllipseItem(event.scenePos().x(), event.scenePos().y(), 0, 0);
			this.current.setPen(this.pen);
			this.scene.addItem(current);
		}
		event.accept();
	}

	/**
	 * If there is already a circle started, continues growing the circle. Otherwise, just accepts the event
	 * 
	 * @param event
	 *        the event that is being acted on
	 */
	public void mouseMoveEvent(QGraphicsSceneMouseEvent event)
	{
		// System.out.println("Circle Mouse hold!");
		if(this.current != null)
		{
			double height = -(this.current.rect().x() - event.scenePos().x());
			if(height == 0)
				height = 1;
			double width = -(this.current.rect().y() - event.scenePos().y());
			if(width == 0)
				width = 1;
			QRectF newCircle = new QRectF(this.current.rect().x(), this.current.rect().y(), height, width);
			// System.out.println("Circle parameters: " + newCircle);
			this.current.setRect(newCircle);
		}
		event.accept();
	}

	/**
	 * Adds the circle that is currently being drawn to the stack and draws the element
	 * 
	 * @param event
	 *        The event causing this action
	 */
	public void mouseReleaseEvent(QGraphicsSceneMouseEvent event)
	{
		if(this.current != null)
		{
			this.scene.removeItem(this.current);
			this.eventItem.emit(new DragDropEllipse(this.current, this.scene));
			this.current = null;
		}
		event.accept();
	}

	@Override
	public DrawingItem copy(DrawingGraphicsScene scene)
	{
		DrawingEllipseItem ret = new DrawingEllipseItem(scene);
		// ret.pen = this.pen.clone();
		if(this.current == null)
			ret.current = null;
		else
			ret.current = new QGraphicsEllipseItem(this.current);
		return ret;
	}
}
