/**
 * 
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard.drawItems;

import com.trolltech.qt.QSignalEmitter;
import com.trolltech.qt.gui.QGraphicsItemInterface;
import com.trolltech.qt.gui.QGraphicsSceneMouseEvent;
import com.trolltech.qt.gui.QPen;
import com.trolltech.qt.gui.QWidget;
import edu.jhu.cs.oose.elevel.AdvancedEditCard.DrawingGraphicsScene;

/**
 * @author Jesse Yates
 */
public abstract class DrawingItem extends QWidget
{
	/**
	 * Build all the pertinent elements from the string: i.e. the location, etc.
	 * 
	 * @param item
	 *        the string to build from
	 */
	public transient QSignalEmitter.Signal1<QGraphicsItemInterface> addItem;
	public transient QSignalEmitter.Signal1<QGraphicsItemInterface> removeItem;
	public transient QSignalEmitter.Signal1<QGraphicsItemInterface> eventItem;

	// public DragDropItem item;
	protected transient QPen pen;
	protected DrawingGraphicsScene scene;

	public DrawingItem()
	{
		this(new DrawingGraphicsScene());

	}

	public void setScene(DrawingGraphicsScene scene)
	{
		if(scene != null)
			this.scene = scene;
	}

	public DrawingItem(DrawingGraphicsScene scene)
	{
		addItem = new QSignalEmitter.Signal1<QGraphicsItemInterface>();
		removeItem = new QSignalEmitter.Signal1<QGraphicsItemInterface>();
		eventItem = new QSignalEmitter.Signal1<QGraphicsItemInterface>();

		this.setScene(scene);
		this.scene.setSelectMode(false);

		this.pen = new QPen(scene.penColor(), scene.penWidth());
	}

	public void setPen(QPen pen)
	{
		this.pen = pen;
	}

	protected DrawingItem copy()
	{
		return this.copy(this.scene);
	}

	public abstract DrawingItem copy(DrawingGraphicsScene scene);

	public abstract void buildFromString(String item);

	public abstract void mousePressEvent(QGraphicsSceneMouseEvent event);

	public abstract void mouseMoveEvent(QGraphicsSceneMouseEvent event);

	public abstract void mouseReleaseEvent(QGraphicsSceneMouseEvent event);

	public DrawingGraphicsScene scene()
	{
		return this.scene;
	}
}
