/**
 * 
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard.drawItems;

import com.trolltech.qt.gui.QGraphicsLineItem;
import com.trolltech.qt.gui.QGraphicsSceneMouseEvent;
import com.trolltech.qt.gui.QLineF;
import com.trolltech.qt.gui.QPen;
import edu.jhu.cs.oose.elevel.AdvancedEditCard.DrawingGraphicsScene;
import edu.jhu.cs.oose.elevel.AdvancedEditCard.dragDrop.DragDropLine;

/**
 * @author Jesse Yates
 */
public class DrawingLineItem extends DrawingItem
{
	//private QGraphicsLineItem currentLine;
	//public QSignalEmitter.Signal1<QGraphicsLineItem> removeItem;
	//public final QSignalEmitter.Signal1<QGraphicsLineItem> addItem = new QSignalEmitter.Signal1<QGraphicsLineItem>();
	public QGraphicsLineItem item;
	private QPen pen;

	public DrawingLineItem(QLineF line, DrawingGraphicsScene scene)
	{
		super(scene);
		this.item = new QGraphicsLineItem(line);
	}

	public DrawingLineItem(DrawingGraphicsScene scene)
	{
		super(scene);
	}

	public DrawingLineItem()
	{
		super(new DrawingGraphicsScene());
	}

	public void setPen(QPen pen)
	{
		this.pen = pen;
		//if(this.item != null)
		//	this.item.setPen(this.pen);
	}

	/*	public String toString()
		{
			StringBuffer buff = new StringBuffer();

			return buff.toString();
		}
	*/
	public void buildFromString(String s)
	{

	}

	/**
	 * If there is already an object at the current location, does not do anything, passes on the mouse click to that
	 * element. Otherwise, creates a line starting at that location
	 * 
	 * @param event
	 *        the event that is being acted on
	 */
	public void mousePressEvent(QGraphicsSceneMouseEvent event)
	{
		System.out.println("line Press event");
		/*if(this.scene.itemAt(event.scenePos()) != null && !this.scene.isSelectMode())
		{
			System.out.println("Item is not null!Press");
			this.item = null;
			//this.scene.itemAt(event.scenePos()).mousePressEvent(event);// setFocus(Qt.FocusReason.MouseFocusReason);
		}
		else*/
		{
			System.out.println("Item is null, adding new line at " + event.scenePos());

			//this.currentLine = new QGraphicsLineItem(new QLineF(event.scenePos(), event.scenePos()));
			//this.currentLine.setPen(new QPen(this.pen.color(), this.pen.widthF() / 3));//new QPen(this.scene().myPenColor, this.myPenWidth));
			//this.currentLine.setAcceptDrops(true);
			//this.addItem.emit(currentLine);
			this.item = this.scene.addLine(new QLineF(event.scenePos(), event.scenePos()), new QPen(this.pen.color(), this.pen.widthF() / 3));
			event.accept();
		}

	}

	/**
	 * If there is already a line started, continues growing the line. Otherwise, just accepts the event
	 * 
	 * @param event
	 *        the event that is being acted on
	 */
	public void mouseMoveEvent(QGraphicsSceneMouseEvent event)
	{
		// System.out.println("Line Mouse hold!");
		if(this.item != null)
		{

			QLineF newLine = new QLineF(this.item.line().p1(), event.scenePos());
			this.item.setLine(newLine);
			this.item.setPen(this.pen);
			event.accept();
		}

	}

	/**
	 * Adds the line that is currently being drawn to the stack and draws the element
	 * 
	 * @param event
	 *        The event causing this action
	 */
	public void mouseReleaseEvent(QGraphicsSceneMouseEvent event)
	{
		System.out.println("Line release event");
		if(this.item != null)
		{
			System.out.println("Line is not null!");
			this.scene.removeItem(this.item);
			this.item = new DragDropLine(this.item, scene);
			//this.currentLine.setPen(this.pen);
			this.eventItem.emit(this.item);

			//System.out.println("Item is null, adding new line " + currentLine.line().p1() + ", " + currentLine.line().p2());

			this.item = null;
			event.accept();

		}
		/*
		else
		{
			if(this.scene.itemAt(event.scenePos()) != null)
				this.scene.itemAt(event.scenePos()).mouseReleaseEvent(event);
		}*/

	}

	@Override
	public DrawingItem copy(DrawingGraphicsScene scene)
	{
		DrawingLineItem ret = new DrawingLineItem(scene);
		ret.item = new QGraphicsLineItem(this.item);
		return ret;
	}

}
