/**
 * 
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard.drawItems;

import com.trolltech.qt.core.QRectF;
import com.trolltech.qt.gui.QGraphicsRectItem;
import com.trolltech.qt.gui.QGraphicsSceneMouseEvent;
import edu.jhu.cs.oose.elevel.AdvancedEditCard.DrawingGraphicsScene;
import edu.jhu.cs.oose.elevel.AdvancedEditCard.dragDrop.DragDropRect;

/**
 * @author Jesse Yates
 */
public class DrawingRectItem extends DrawingItem
{
	QGraphicsRectItem drawingSquare;

	public DrawingRectItem(DrawingGraphicsScene scene, double x, double y, double height, double width)
	{
		super(scene);
		drawingSquare = new QGraphicsRectItem(x, y, height, width);
	}

	public DrawingRectItem(DrawingGraphicsScene scene)
	{
		super(scene);
	}

	public DrawingRectItem()
	{
		super(new DrawingGraphicsScene());
	}

	public String toString()
	{
		StringBuffer b = new StringBuffer();
		return b.toString();
	}

	/**
	 * @see edu.jhu.cs.oose.elevel.AdvancedEditCard.DrawItems.development.DrawingItem#buildFromString(java.lang.String)
	 */
	public void buildFromString(String item)
	{
		// TODO Auto-generated method stub

	}

	/**
	 * If there is already an object at the current location, does not do anything, passes on the mouse click to that
	 * element. Otherwise, creates a square starting at that location
	 * 
	 * @param event
	 *        the event that is being acted on
	 */
	public void mousePressEvent(QGraphicsSceneMouseEvent event)
	{
		System.out.println("Rect Press event");

		this.drawingSquare = new QGraphicsRectItem(event.scenePos().x(), event.scenePos().y(), 0, 0);
		this.drawingSquare.setPen(this.pen);
		this.scene.addItem(drawingSquare);
		event.accept();
	}

	/**
	 * If there is already a square started, continues growing the square. Otherwise, just accepts the event
	 * 
	 * @param event
	 *        the event that is being acted on
	 */
	public void mouseMoveEvent(QGraphicsSceneMouseEvent event)
	{
		if(this.drawingSquare != null)
		{
			double height = -(this.drawingSquare.rect().x() - event.scenePos().x());
			if(height == 0)
				height = 1;
			double width = -(this.drawingSquare.rect().y() - event.scenePos().y());
			if(width == 0)
				width = 1;
			QRectF newRect = new QRectF(this.drawingSquare.rect().x(), this.drawingSquare.rect().y(), height, width);
			//this.drawingSquare.prepareGeometryChange();
			this.drawingSquare.setRect(newRect);
			this.scene().update(this.rect().x() - 2, this.rect().y() - 2, this.rect().height() + 4, this.rect().width() + 4);
			event.accept();
		}
		else
			event.ignore();
	}

	/**
	 * Adds the square that is currently being drawn to the stack and draws the element
	 * 
	 * @param event
	 *        The event causing this action
	 */
	public void mouseReleaseEvent(QGraphicsSceneMouseEvent event)
	{
		if(this.drawingSquare != null)
		{
			this.scene.removeItem(this.drawingSquare);
			this.eventItem.emit(new DragDropRect(this.drawingSquare, scene));
			this.drawingSquare = null;
		}
		event.accept();
	}

	@Override
	public DrawingItem copy(DrawingGraphicsScene scene)
	{
		DrawingRectItem ret = new DrawingRectItem(scene);
		//ret.pen = this.pen.clone();
		if(this.drawingSquare != null)
			ret.drawingSquare = new QGraphicsRectItem(this.drawingSquare);
		else
			ret.drawingSquare = null;
		return ret;
	}

}
