/**
 * 
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard.drawItems;

/**
 * Define the different types of the drawings that can be performed by the DefaultCanvas
 * 
 * @author Jesse Yates
 */
public enum DrawingType
{

	TEXT, LINE, CIRCLE, RECTANGLE, REDO, SELECT;

	public String toString()
	{
		if(this.equals(DrawingType.TEXT))
			return "Text";
		if(this.equals(DrawingType.LINE))
			return "Line";
		if(this.equals(DrawingType.CIRCLE))
			return "Circle";
		if(this.equals(DrawingType.RECTANGLE))
			return "Square";
		if(this.equals(DrawingType.SELECT))
			return "Select";
		return null;
	}

	public DrawingItem getItem()
	{
		if(this.equals(DrawingType.TEXT))
			return new DrawingTextItem();
		if(this.equals(DrawingType.LINE))
			return new DrawingLineItem();
		if(this.equals(DrawingType.CIRCLE))
			return new DrawingEllipseItem();
		if(this.equals(DrawingType.RECTANGLE))
			return new DrawingRectItem();
		if(this.equals(DrawingType.SELECT))
			return new DrawingSelectItem();
		return null;
	}
}
