/**
 * Button.java
 * Group 7, Object Oriented Software Engineering
 * October 10, 2009
 */
package edu.jhu.cs.oose.elevel.editing;

import com.trolltech.qt.gui.QPushButton;

/**
 * Class representing a button on a {@link ToolBar}
 * 
 * @author Jesse Yates
 */
public abstract class Button extends QPushButton
{
	/**
	 * The toolbar this <code>Button</code> belongs to
	 */
	@SuppressWarnings("unused")
	private ToolBar toolbar;

	public Button(ToolBar parent)
	{
		this.toolbar = parent;
	}

	/**
	 * Add an {@link ActionCommand} to this object
	 * 
	 * @param a
	 *        The action to add to this object
	 */
	public abstract void addAction(ActionCommand a);

	/**
	 * Push the <code>Button</code> - updates the tool in the <code>Toolbar</code>
	 */
	public abstract void pushButton();

}
