/**
 * Toolbar.java
 * Group 7, Object Oriented Software Engineering
 * October 10, 2009
 */
package edu.jhu.cs.oose.elevel.editing;

import com.trolltech.qt.gui.QToolBar;
import com.trolltech.qt.gui.QWidget;
import edu.jhu.cs.oose.elevel.utilities.Face;

/**
 * An interface that all card-editing toolbars must implement. A <code>ToolBar</code> consists of {@link Button}s that
 * represent various functionality.
 * 
 * @author Jesse Yates
 */
public abstract class ToolBar extends QToolBar
{
	Face selected;

	abstract QWidget getFaceCanvas(Face f, String string);

	/**
	 * changes which face currently selected
	 */
	void setSelected(Face f)
	{
		this.selected = f;
	}
}
