package edu.jhu.cs.oose.elevel.testTaking;

public class AdaptiveTestAlgorithm extends ProbabilisticTestAlgorithm
{
	public AdaptiveTestAlgorithm(int cardCount, boolean repeat, float[] probabilities)
	{
		super(cardCount, repeat, probabilities);
	}

	@Override
	public void cardAnswered(boolean correct)
	{
		if(correct)
			changeProbability(currentCardIndex, 0);
		else
			changeProbability(currentCardIndex, 1 - (1 - probabilities[currentCardIndex]) / 2);
	}

	@Override
	public int nextCard()
	{
		if(allCardsVisited() && !repeat)
			return -1;

		double selection = super.rand.nextDouble();

		currentCardIndex = -1;
		float cummulativeSum = 0;
		for(int i = 0; i < probabilities.length; i++)
		{
			cummulativeSum += probabilities[i];
			if(selection <= cummulativeSum)
			{
				currentCardIndex = i;
				break;
			}
		}
		cardSelected[currentCardIndex] = true;

		return currentCardIndex;
	}
}
