/**
 * RandomTestAlgorithm.java
 * Group 7, Object Oriented Software Engineering
 * November 15, 2009
 */
package edu.jhu.cs.oose.elevel.testTaking;

public class RandomTestAlgorithm extends ProbabilisticTestAlgorithm
{
	public RandomTestAlgorithm(int cardCount, boolean repeat, float[] probabilities)
	{
		super(cardCount, repeat, probabilities);
	}

	@Override
	public int nextCard()
	{
		if(allCardsVisited() && !repeat)
			return -1;

		double selection = super.rand.nextDouble();

		currentCardIndex = -1;
		float cummulativeSum = 0;
		for(int i = 0; i < probabilities.length; i++)
		{
			cummulativeSum += probabilities[i];
			if(selection <= cummulativeSum)
			{
				currentCardIndex = i;
				break;
			}
		}
		cardSelected[currentCardIndex] = true;

		// for the card we just selected, reduce the probability of selecting this card in the future (implicitly
		// increasing the chance of selecting every other card)
		changeProbability(currentCardIndex, probabilities[currentCardIndex] / cardCount);

		return currentCardIndex;
	}
}
